
string fnames[1 .. 90] = ...;

main {

  //var fnames = new Array(90); // this can also be done by hardcoding the names here
  //fnames[0] = "16_1_2c_Uniform_3c";
  //fnames[1] = "16_1_Uniform_Noon_16";

  //create an empty model that reads the filenames  
  var indata = new IloOplDataSource("testMain2.dat");
  var fSource = new IloOplModelSource("empty.mod");
  var fCplex = new IloCplex();
  var fDef = new IloOplModelDefinition(fSource);
  var fOpl = new IloOplModel(fDef, fCplex);
  fOpl.addDataSource(indata);
  var ext = "";
  var maxsteps = 4;

  //var startV=1;startK=1;startBase=1; 
  var startV=32,startK=5,startBase=4;
  for(var v=startV; v <=60; v++) {  // run failed 16/01/2016 @ 11:18pm on v=32,k=5,BaseModelOnly=4
  //for ( var v = 7; v <= 7; v++) {
    var fname = fOpl.dataElements.fnames[v]; //"16_1_2c_Noon_3c";
    for (var k=(v==startV ? startK : 1); k<=10;k++) {
      //for ( var k = 5; k <= 5; k++) {
      // run new model only for instances after 40, otherwise all variants
      for ( var BaseModelOnly = (v==startV && k==startK) ? startBase : (v<=40 ? 1 : 9); 
      		    BaseModelOnly <= 9; BaseModelOnly++) {
        //for ( var BaseModelOnly = 0; BaseModelOnly <= ((v <= 40) ? 0 : 1); BaseModelOnly++) {
        if (BaseModelOnly >= 1) {
          ext = "_base";
          if(BaseModelOnly > 1) { ext += "+" + (BaseModelOnly-1); }
        } else {
          if (maxsteps > 1) {
            ext = "_ZD" + maxsteps;
          } else {
            ext = "_yyy";
          }
        }
        writeln("Solving", ext, ": ", fname, " count: ", v, " instance: ", k,
            " =======================");
        var data = new IloOplDataSource("inputData/" + fname + "_" + k + ".dat");

        var m1Source = new IloOplModelSource("test.mod");
        var m1Cplex = new IloCplex();
        var m1Def = new IloOplModelDefinition(m1Source);
        var m1Opl = new IloOplModel(m1Def, m1Cplex);
        m1Opl.addDataSource(data);
        // hacked way to override variables from main script
        var tmpfile = new IloOplOutputFile("tmp.dat");
        tmpfile.write("BaseModelOnly = " + BaseModelOnly + ";\n");
        tmpfile.write("maxsteps = " + maxsteps + ";\n");
        tmpfile.close()
        m1Opl.addDataSource(new IloOplDataSource("tmp.dat"));

        // process the input data
        //for(var v1 =1; v1 <= m1Opl.dataElements.maxvessel; v1++){
        //    var p1 = round(m1Opl.dataElements.P[v1]);
        //    m1Opl.dataElements.P[v1] = p1;
        //}
        write("B-E:");
        for ( var i = 1; i <= m1Opl.dataElements.maxperiod; i++) {
          write(" ", m1Opl.dataElements.B[i], "-", m1Opl.dataElements.E[i]);
        }
        write("\nP/L:");
        for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
          m1Opl.dataElements.ArrivalTime[v1] = Opl
              .round(m1Opl.dataElements.ArrivalTime[v1]);
          m1Opl.dataElements.P[v1] = Opl.round(m1Opl.dataElements.P[v1]);
          m1Opl.dataElements.L[v1] = Opl
              .round(m1Opl.dataElements.L[v1] * 10000) / 10000.0;
        }
        if (BaseModelOnly == 0) { // use tightening rules
          var Lmin = m1Opl.dataElements.L[1];
          for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
            if (m1Opl.dataElements.L[v1] < Lmin) {
              Lmin = m1Opl.dataElements.L[v1];
            }
          }
          for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
            var C = m1Opl.dataElements.ArrivalTime[v1]
                + m1Opl.dataElements.P[v1];
            for ( var i = 1; i <= m1Opl.dataElements.maxperiod; i++) {
              if (C <= m1Opl.dataElements.E[i]) { // first high tide window
                if (m1Opl.dataElements.B[i] <= C) {
                  break;
                }// OK during high tide  
                m1Opl.dataElements.ArrivalTime[v1] += m1Opl.dataElements.B[i]
                    - C;
                break; //earliest feasible start of loading
              }
            }
            if (m1Opl.dataElements.L[v1] + Lmin > m1Opl.dataElements.lmax + 1e-5) {
              m1Opl.dataElements.L[v1] = m1Opl.dataElements.lmax;
            }
          }
          // branching priority - first on Z, then ZD variables, then the rest
          for (i in m1Opl.vessel) {
            for ( var t in m1Opl.period) {
              m1Cplex.setPriority(m1Opl.Z[i][t], 2); // branch first
              if (m1Opl.maxsteps > 1) {
                for ( var st in m1Opl.steps) {
                  m1Cplex.setPriority(m1Opl.ZD[i][t][st], 1);
                }
              }
            }
          }
        }
        for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
          write(" ", m1Opl.dataElements.P[v1], "/", m1Opl.dataElements.L[v1]);

        }
        write("\nETA:");
        for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
          write(" ", m1Opl.ArrivalTime[v1]);
        }
        writeln();

        m1Opl.generate();
        var time1 = m1Cplex.getCplexTime();
        m1Cplex.tilim = "3600";
        m1Cplex.threads = "8";
        /*
         //m1Cplex.repeatpresolve=0; // causes errors with scenario: 16_1_Uniform_Noon_16 count : 3
         //m1Cplex.fracpass=1000;
         m1Cplex.repeatpresolve=3; // -1 auto,0=off,3=on with the lot
         m1Cplex.aggcutlim=4; // default=3
         m1Cplex.gubcovers=-1; // not very useful
         m1Cplex.disjcuts=2; // 3=very aggressive (slow but seems to help heuristic)
         m1Cplex.implbd=-1; // 2=aggressive
         m1Cplex.cliques=-1; // -1=off 3=very aggressive
         m1Cplex.fraccuts=-1; // -1=off 2=aggressive
         */
        if (BaseModelOnly == 0) { // tuned parameters for tighened formulation
          m1Cplex.objdif = 0.99; // solutions must be integer
          m1Cplex.covers = -1; // 3 = very aggressive
          m1Cplex.mircuts = -1; // -1 off, 2=aggressive
          // -1 =min infeasibility  1=max infeasibility (works badly)
          // 2=pseudo costs 4=pseudo reduced costs (better)  
          m1Cplex.varsel = 4; // 3=strong branching, 0=automatic
          m1Cplex.probe = -1; // -1 off - 3 very aggressive probing
          //m1Cplex.fpheur=2; // feasbility pump with emphasis on optimality
          // solution polishing parameter has been set in a way that is 
          // "cheating" to a degree. It only really activates for problems that we can't solve
          m1Cplex.polishaftertime = 900; // polish solution - slow but useful for "hard" problems (not solved in 15min)
          //m1Cplex.symmetry=5; // extremely super aggessive symmetry breaking (doesn't help) 
          //m1Cplex.mipemphasis=1; //1=feasiblity, 2=optimality, 3=maxLB, 4=minFeas
        }
        var UB = -1;
        var LB = -1;
        var rootLB = -1;
        var rootUB = -1;
        var rootTime = -1
        m1Cplex.nodelim = 0;
        var OK = m1Cplex.solve();
        rootTime = m1Cplex.getCplexTime() - time1;
        m1Cplex.nodelim = 99999999;
        m1Cplex.tilim = 3600.0 - rootTime;
        rootLB = m1Cplex.getBestObjValue();
        if (OK) { // have an upper bound solution
          rootUB = m1Cplex.getObjValue();
        }
        writeln("Found root upper/lower bound ", rootUB, " / ", rootLB, " in ",
            rootTime, " sec");
        OK = m1Cplex.solve();
        if (OK) {
          UB = m1Cplex.getObjValue();
          LB = m1Cplex.getBestObjValue();
          writeln("final solution for scn ", k, " =", UB);
          writeln("final bound for scn ", k, " =", LB);
        } else {
          writeln("Failed with status ", m1Cplex.getCplexStatus());
          writeln("1=Optimal, 2=Unbounded, 3=infeasible, 4=2or3, 10-13=stopped prematurely");
          m1Cplex.exportModel("bap.lp");
          writeln("Wrote bap.lp");
        }

        var time = m1Cplex.getCplexTime() - time1;

        //opening a text file
        var writeOut = 0;
        if( writeOut  ) {
        var ofile = new IloOplOutputFile("outputData/" + fname + ext + "S" + k
            + ".out");
        //copying solution to the text file
        // write summary to ofile because sumfile can take a long t  
        ofile.write("csv,", fname, ",", k, ",", UB, ",", LB, ",", time, ",");
        ofile.write(rootUB, ",", rootLB, ",", rootTime, ",", m1Cplex
            .getNnodes(), ",");
        if (OK) {
          ofile.writeln();
        } else {
          ofile.writeln("failed: ", m1Cplex.getCplexStatus());
        }
        ofile.writeln("Total running time = ", time, " seconds\n");
        ofile.writeln("Objective Function value  = ", UB, "\n\n");
        ofile.writeln("Best Bound value  = ", LB, "\n\n");
        ofile.writeln("Final solution: \n");
      }        
        var sumfile = new IloOplOutputFile("summary" + ext + ".csv", true); // append
        sumfile.write(fname, ",");
        sumfile.write(k, ",");
        sumfile.write(UB, ",");
        sumfile.write(LB, ",");
        sumfile.write(time, ",");
        sumfile.write(rootUB, ",", rootLB, ",", rootTime, ",");
        sumfile.write(m1Cplex.getNnodes(), ",");

     if(writeOut) {
        // dump problem data to outfile
        ofile.write("B=[");
        for ( var i = 1; i <= m1Opl.dataElements.maxperiod; i++) {
          ofile.write((i == 1 ? " " : ","), m1Opl.dataElements.B[i]);
        }
        ofile.writeln(" ]");
        ofile.write("E=[");
        for ( var i = 1; i <= m1Opl.dataElements.maxperiod; i++) {
          ofile.write((i == 1 ? " " : ","), m1Opl.dataElements.E[i]);
        }
        ofile.writeln(" ]");
        ofile.write("P=[");
        for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
          ofile.write((v1 == 1 ? " " : ","), m1Opl.dataElements.P[v1]);
        }
        ofile.writeln(" ]");
        ofile.write("L=[");
        for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
          ofile.write((v1 == 1 ? " " : ","), m1Opl.dataElements.L[v1]);
        }
        ofile.writeln(" ]");
        ofile.write("ArrivalTime=[");
        for ( var v1 = 1; v1 <= m1Opl.dataElements.maxvessel; v1++) {
          ofile
              .write((v1 == 1 ? " " : ","), m1Opl.dataElements.ArrivalTime[v1]);
        }
        ofile.writeln(" ]");
		}
        if (OK) {
          sumfile.write("\n");
        } else {
          sumfile.write("failed: ", m1Cplex.getCplexStatus(), "\n");
        }
        sumfile.close(); // force flushing
        if (OK && writeOut) {
          for ( var i in m1Opl.vessel) {

            ofile.writeln("S[", i, "]=", m1Opl.S[i]);

          }
          ofile.writeln();

          for ( var i in m1Opl.vessel) {
            ofile.writeln("C[", i, "]=", m1Opl.C[i]);
          }
          ofile.writeln();

          for ( var i in m1Opl.vessel) {
            ofile.writeln("Y[", i, "]=", m1Opl.Y[i]);
          }
          ofile.writeln();

          for ( var i in m1Opl.vessel) {
            for ( var j in m1Opl.vessel1) {
              ofile.writeln("X[", i, "][", j, "]=", m1Opl.X[i][j]);
            }
          }
          ofile.writeln();

          for (i in m1Opl.vessel) {
            for (j in m1Opl.vessel1) {
              ofile.writeln("I[", i, "][", j, "]=", m1Opl.I[i][j]);
            }
          }
          ofile.writeln();

          for (i in m1Opl.vessel) {
            for ( var t in m1Opl.period) {
              ofile.writeln("Z[", i, "][", t, "]=", m1Opl.Z[i][t]);
            }
          }
          if (BaseModelOnly == 0 && m1Opl.UseW > 0) {
            for (i in m1Opl.vessel) {
              for ( var t in m1Opl.period) {
                if (m1Opl.W[i][t] > 0) {
                  ofile.writeln("W[", i, "][", t, "]=", m1Opl.W[i][t], " = ",
                      m1Opl.W[i][t] * m1Opl.dataElements.P[i], " hrs");
                }
              }
            }
          }
        }

        writeln("Completed in ", time, " sec", "  wrote summary", ext, ".csv");
        time1 = time;

        if(writeOut){ ofile.close(); }
        m1Opl.end();
        m1Def.end();
        m1Cplex.clearModel();
        m1Cplex.end();
        m1Source.end();

        sumfile.close(); // should already be closed

      } // end loop over basemodel
    } // end loop over vessels v1
  } // end loop over k
  writeln("All done ##################################################################\n" );
} // end main
